#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Module that holds example calculator for testing

@author: hoelken
"""

from time import time_ns
from .computers import Hal9000


class Calc:
    """
    Simple calculator class
    """

    def __init__(self, val):
        #: The value to calculate with
        self.val = val

    def add(self, other):
        """
        Add a value to the internal value. The internal value remains unchanged

        :param other: the other value to add
        :return: the sum of our value with the other
        """
        return self.val + other

    def random_division(self, factor: int = 1):
        """
        :return: the random value generated by HAL9000 divided by our value
        """
        return Hal9000('Dave').random(factor=factor) / self.val

    def time_times_value(self):
        """
        Multiply the current NS timestamp by our internal value

        :return: the product of timestamp and value
        """
        return time_ns() * self.val
